/**
 * <p>Title: Computer Science 375 Assignment 1</p>
 * <p>University:: University of Auckland</p>
 * <p>@author NN NN</p>
 * <p>UPI: nnnn001</p>
 * ID: 7654321
 * 
 */
#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "glu32.lib")
#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <atlstr.h>
#include <atlimage.h>


using namespace std;

#define A1_SCREEN_DEPTH 32
#define A1_SCREEN_WIDTH 1024
#define A1_SCREEN_HEIGHT 700
#define A1_VIEW_WIDTH 1015
#define A1_VIEW_HEIGHT 665
#define A1_HIS_WIDTH 256
#define A1_HIS_HEIGHT 256

//the image file name
const static char *IMAGE_FILE="test.jpg";

//the texture parameters for the source image
GLubyte *texture;
int texWidth,texHeight;
//the position of the source image
int imgPosX,imgPosY=310;

//the position of the histograms
const static int HIS_BAR_Y=10;
const static int HIS_BAR_H=10;
const static int HIS_R_X=64;
const static int HIS_R_Y=30;
const static int HIS_G_X=384;
const static int HIS_G_Y=30;
const static int HIS_B_X=704;
const static int HIS_B_Y=30;
GLubyte *hisTexR,*hisTexG,*hisTexB;
GLubyte *hisBarR,*hisBarG,*hisBarB;

//for displaying system information
const static int BIAS_Y=20;
char info[1024];
char infoUp[1024];
char infoDown[1024];
char strTemp[256];//for temp use

//display list of fonts
UINT fontListId=0;
//the constant variables for write fonts
const static int MAXCHARS=256;
const static int FONTHEIGHT=16;

//mouse point related parameters
int xPos,yPos;//current mouse positions
bool inImage=false;

//for OpenGL use
HDC hdc;
HGLRC hrc;

//the x y is the world coordinates
void drawWindow(int x,int y)
{
	glColor3f(1,0,0);
	glBegin(GL_LINE_LOOP);
	glVertex2i(x-5,y-5);
	glVertex2i(x-5,y+5);
	glVertex2i(x+5,y+5);
	glVertex2i(x+5,y-5);
	glEnd();
}

//set the pixel format for OpenGL
bool bSetupPixelFormat(HDC hdc) 
{ 
    PIXELFORMATDESCRIPTOR pfd;
    int pixelformat; 
    pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR); // Set the size of the structure
    pfd.nVersion = 1; // Always set this to 1

    // Pass in the appropriate OpenGL flags
    pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER; 
    pfd.dwLayerMask = PFD_MAIN_PLANE;    // the standard mask 
    pfd.iPixelType = PFD_TYPE_RGBA;      // RGBA pixel type
    pfd.cColorBits = A1_SCREEN_DEPTH;       // define for the color bits
    pfd.cDepthBits = A1_SCREEN_DEPTH;       
    pfd.cAccumBits = 0;                  // No special bitplanes needed
    pfd.cStencilBits = 0;                // no stencil bits

    // This gets us a pixel format that best matches the one passed in from the device
    if ( (pixelformat = ChoosePixelFormat(hdc, &pfd)) == FALSE ) 
    { 
        MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK); 
        return FALSE; 
    } 

    // This sets the pixel format that we extracted from above
    if (SetPixelFormat(hdc, pixelformat, &pfd) == FALSE) 
    { 
        MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK); 
        return FALSE; 
    } 
return TRUE; // Return if success
}

//handle events
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR key;
	
	switch (message) 
	{
		case WM_DESTROY:
		PostQuitMessage(0);
		break;
	
	
	case WM_CHAR://change the eye position
		key=(TCHAR)wParam;
		break;
	
	case WM_MOUSEMOVE:
		xPos=LOWORD(lParam);
		yPos=HIWORD(lParam);
		if(A1_VIEW_HEIGHT-yPos>imgPosY&&A1_VIEW_HEIGHT-yPos<imgPosY+texHeight&&xPos>(A1_VIEW_WIDTH-texWidth)/2&&xPos<(A1_VIEW_WIDTH+texWidth)/2)
			inImage=true;
		else
			inImage=false;
		
		break;
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

//draw the text information
void drawText(int x,int y,char* text)
{
	//do protection of current environment params
	//and load identity
	glPushAttrib( GL_TRANSFORM_BIT | GL_VIEWPORT_BIT );
	glMatrixMode( GL_PROJECTION );						
	glPushMatrix();										
	glLoadIdentity();									
	glMatrixMode( GL_MODELVIEW );						
	glPushMatrix();										
	glLoadIdentity();
	y=A1_SCREEN_HEIGHT-FONTHEIGHT-y;
	glViewport(x-1,y-1,0,0);
	glRasterPos4f(0,0,0,1);
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glPopAttrib();
	//using display list
	glPushAttrib(GL_LIST_BIT);
	glListBase((GLsizei)fontListId);
	glCallLists((GLsizei)strlen(text),GL_UNSIGNED_BYTE,text);
	glPopAttrib();
}
//the x,y is the index within the image
//from left to right, bottom to top
float getMean(int x,int y)
{
	int xStart,xEnd,yStart,yEnd;
	if(y<5)
		yStart=0;
	else
		yStart=y-5;
	if(x<5)
		xStart=0;
	else
		xStart=x-5;
	if(y>texHeight-6)
		yEnd=texHeight-1;
	else
		yEnd=y+5;
	if(x>texWidth-6)
		xEnd=texWidth-1;
	else
		xEnd=x+5;
	int sum=0;
	for(int i=yStart;i<=yEnd;i++)
		for(int j=xStart;j<=xEnd;j++)
			sum+=texture[(texWidth*i+j)*3]+texture[(texWidth*i+j)*3+1]+texture[(texWidth*i+j)*3+2];
	return sum/363.0f;
}
float getVariance(int x,int y,float mean)
{
	int xStart,xEnd,yStart,yEnd;
	if(y<5)
		yStart=0;
	else
		yStart=y-5;
	if(x<5)
		xStart=0;
	else
		xStart=x-5;
	if(y>texHeight-6)
		yEnd=texHeight-1;
	else
		yEnd=y+5;
	if(x>texWidth-6)
		xEnd=texWidth-1;
	else
		xEnd=x+5;
	float sum=0;
	for(int i=yStart;i<=yEnd;i++)
		for(int j=xStart;j<=xEnd;j++)
			sum+=((texture[(texWidth*i+j)*3]+texture[(texWidth*i+j)*3+1]+texture[(texWidth*i+j)*3+2])/3.0f-mean)
				*((texture[(texWidth*i+j)*3]+texture[(texWidth*i+j)*3+1]+texture[(texWidth*i+j)*3+2])/3.0f-mean);
	return sum/121;
}

//display the images and histograms
void display()
{

	glClearColor(1,1,1,0);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0,A1_VIEW_WIDTH,0,A1_VIEW_HEIGHT);
	
	glRasterPos2i(imgPosX,imgPosY);
	glDrawPixels(texWidth,texHeight,GL_RGB,GL_UNSIGNED_BYTE,texture);

	//show the histograms
	//red
	glRasterPos2i(HIS_R_X,HIS_R_Y);
	glDrawPixels(A1_HIS_WIDTH,A1_HIS_HEIGHT,GL_RGB,GL_UNSIGNED_BYTE,hisTexR);
	glRasterPos2i(HIS_R_X,HIS_BAR_Y);
	glDrawPixels(A1_HIS_WIDTH,HIS_BAR_H,GL_RGB,GL_UNSIGNED_BYTE,hisBarR);
	//green
	glRasterPos2i(HIS_G_X,HIS_G_Y);
	glDrawPixels(A1_HIS_WIDTH,A1_HIS_HEIGHT,GL_RGB,GL_UNSIGNED_BYTE,hisTexG);
	glRasterPos2i(HIS_G_X,HIS_BAR_Y);
	glDrawPixels(A1_HIS_WIDTH,HIS_BAR_H,GL_RGB,GL_UNSIGNED_BYTE,hisBarG);
	//blue
	glRasterPos2i(HIS_B_X,HIS_B_Y);
	glDrawPixels(A1_HIS_WIDTH,A1_HIS_HEIGHT,GL_RGB,GL_UNSIGNED_BYTE,hisTexB);
	glRasterPos2i(HIS_B_X,HIS_BAR_Y);
	glDrawPixels(A1_HIS_WIDTH,HIS_BAR_H,GL_RGB,GL_UNSIGNED_BYTE,hisBarB);

	if(inImage)
	{
		drawWindow(xPos,A1_VIEW_HEIGHT-yPos);
		int imgX=xPos-imgPosX;int imgY=A1_VIEW_HEIGHT-yPos-imgPosY;
		//display the R,G,B values of the pixel
		strcpy(infoUp,"R:");
		_itoa(texture[(imgY*texWidth+imgX)*3],strTemp,10);
		strcat(infoUp,strTemp);
		strcat(infoUp," G:");
		_itoa(texture[(imgY*texWidth+imgX)*3+1],strTemp,10);
		strcat(infoUp,strTemp);
		strcat(infoUp," B:");
		_itoa(texture[(imgY*texWidth+imgX)*3+2],strTemp,10);
		strcat(infoUp,strTemp);
		drawText(xPos-strlen(infoUp)*3,yPos+20-BIAS_Y,infoUp);
		
		//display the intensity and mean and variance
		float intensity=((unsigned int)texture[(imgY*texWidth+imgX)*3]+(unsigned int)texture[(imgY*texWidth+imgX)*3+1]+(unsigned int)texture[(imgY*texWidth+imgX)*3+2])/3.0f;
		strcpy(infoDown,"Intensity:");
		_gcvt(intensity,5,strTemp);
		strcat(infoDown,strTemp);//_fcvt(intensity,2,&temp1,&temp2));
		strcat(infoDown," Mean:");
		float mean=getMean(imgX,imgY);
		_gcvt(mean,5,strTemp);
		strcat(infoDown,strTemp);
		strcat(infoDown," Variance:");
		_gcvt(getVariance(imgX,imgY,mean),5,strTemp);
		strcat(infoDown,strTemp);
		drawText(xPos-strlen(infoDown)*3,yPos+20+BIAS_Y,infoDown);
		
	}
	
	//show system information
	drawText(20,50,info);
	glFlush();
	SwapBuffers(hdc);
}

//load the image, do the calculation for showing the histograms
void loadRes()
{
	//the histograms' statistics
	int statR[A1_HIS_WIDTH],statG[A1_HIS_WIDTH],statB[A1_HIS_WIDTH];
	//initialize the statistics' values
	for(int i=0;i<A1_HIS_WIDTH;i++)
	{
		statR[i]=0;statG[i]=0;statB[i]=0;
	}

	//image pixel values
	CImage image;
	image.Destroy();
	HRESULT hResult=image.Load(IMAGE_FILE);
	if(FAILED(hResult))
	{
		strcpy(info,"Failed loading source image.");return;
	}
	texWidth=image.GetWidth();
	texHeight=image.GetHeight();
	texture = new GLubyte[texWidth*texHeight*3];
	for(int i=0;i<texHeight;i++)
		for(int j=0;j<texWidth;j++)
		{
			COLORREF color=image.GetPixel(j,texHeight-i-1);
			texture[(i*texWidth+j)*3]=(GLubyte)GetRValue(color);
			statR[(int)GetRValue(color)]++;
			texture[(i*texWidth+j)*3+1]=(GLubyte)GetGValue(color);
			statG[(int)GetGValue(color)]++;
			texture[(i*texWidth+j)*3+2]=(GLubyte)GetBValue(color);
			statB[(int)GetBValue(color)]++;
			
		}

	//get the maximum values of histogram in order to get suitable position
	int maxIntensity=0;
	for(int i=0;i<A1_HIS_WIDTH;i++)
	{
		if(statR[i]>maxIntensity)maxIntensity=statR[i];
		if(statG[i]>maxIntensity)maxIntensity=statG[i];
		if(statB[i]>maxIntensity)maxIntensity=statB[i];
	}
	//calculate the position of the source image
	//supposed to be at center
	imgPosX=(A1_SCREEN_WIDTH-texWidth)/2;
	
	//generate the histogram's texture
	hisTexR=new GLubyte[A1_HIS_HEIGHT*A1_HIS_WIDTH*3];
	hisTexG=new GLubyte[A1_HIS_HEIGHT*A1_HIS_WIDTH*3];
	hisTexB=new GLubyte[A1_HIS_HEIGHT*A1_HIS_WIDTH*3];
	for(int i=0;i<A1_HIS_HEIGHT;i++)
		for(int j=0;j<A1_HIS_WIDTH;j++)
		{
			if(statR[j]*A1_HIS_HEIGHT/maxIntensity>=i)
			{
				hisTexR[(i*A1_HIS_WIDTH+j)*3]=100;
				hisTexR[(i*A1_HIS_WIDTH+j)*3+1]=0;
				hisTexR[(i*A1_HIS_WIDTH+j)*3+2]=0;
			}else
			{
				hisTexR[(i*A1_HIS_WIDTH+j)*3]=255;
				hisTexR[(i*A1_HIS_WIDTH+j)*3+1]=255;
				hisTexR[(i*A1_HIS_WIDTH+j)*3+2]=255;
			}
			if(statG[j]*A1_HIS_HEIGHT/maxIntensity>=i)
			{
				hisTexG[(i*A1_HIS_WIDTH+j)*3]=0;
				hisTexG[(i*A1_HIS_WIDTH+j)*3+1]=100;
				hisTexG[(i*A1_HIS_WIDTH+j)*3+2]=0;
			}else
			{
				hisTexG[(i*A1_HIS_WIDTH+j)*3]=255;
				hisTexG[(i*A1_HIS_WIDTH+j)*3+1]=255;
				hisTexG[(i*A1_HIS_WIDTH+j)*3+2]=255;
			}
			if(statB[j]*A1_HIS_HEIGHT/maxIntensity>=i)
			{
				hisTexB[(i*A1_HIS_WIDTH+j)*3]=0;
				hisTexB[(i*A1_HIS_WIDTH+j)*3+1]=0;
				hisTexB[(i*A1_HIS_WIDTH+j)*3+2]=100;
			}else
			{
				hisTexB[(i*A1_HIS_WIDTH+j)*3]=255;
				hisTexB[(i*A1_HIS_WIDTH+j)*3+1]=255;
				hisTexB[(i*A1_HIS_WIDTH+j)*3+2]=255;
			}
		}
	
	//generate the histogram bar texture
	hisBarR=new GLubyte[A1_HIS_WIDTH*HIS_BAR_H*3];
	hisBarG=new GLubyte[A1_HIS_WIDTH*HIS_BAR_H*3];
	hisBarB=new GLubyte[A1_HIS_WIDTH*HIS_BAR_H*3];
	for(int i=0;i<HIS_BAR_H;i++)
		for(int j=0;j<A1_HIS_WIDTH;j++)
		{
			hisBarR[(A1_HIS_WIDTH*i+j)*3]=j;
			hisBarR[(A1_HIS_WIDTH*i+j)*3+1]=0;
			hisBarR[(A1_HIS_WIDTH*i+j)*3+2]=0;

			hisBarG[(A1_HIS_WIDTH*i+j)*3]=0;
			hisBarG[(A1_HIS_WIDTH*i+j)*3+1]=j;
			hisBarG[(A1_HIS_WIDTH*i+j)*3+2]=0;

			hisBarB[(A1_HIS_WIDTH*i+j)*3]=0;
			hisBarB[(A1_HIS_WIDTH*i+j)*3+1]=0;
			hisBarB[(A1_HIS_WIDTH*i+j)*3+2]=j;
		}

}

//release the resources
void releaseRes()
{
	delete hisBarR;delete hisBarG;delete hisBarB;
	delete hisTexR;delete hisTexG;delete hisTexB;
	delete texture;
}

int WINAPI _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	HWND hWnd;
	MSG msg;
	//window class & set up the properties
	WNDCLASSEX win;
	win.cbSize=sizeof(WNDCLASSEX);
	win.style=CS_VREDRAW|CS_HREDRAW;
	win.lpfnWndProc=WndProc;
	win.cbClsExtra=0;
	win.cbWndExtra=0;
	win.hInstance=hInstance;
	win.hIcon=LoadIcon(NULL,IDI_WINLOGO);
	win.hCursor=LoadCursor(NULL,IDC_ARROW);
	win.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	win.lpszMenuName=NULL;
	win.lpszClassName="win";
	win.hIconSm=LoadIcon(NULL,IDI_WINLOGO);
	RegisterClassEx(&win);//regist win class
	//create window & show
	hWnd=CreateWindow("win","Computer Science 375 Assignment1",
		WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,A1_SCREEN_WIDTH,A1_SCREEN_HEIGHT,NULL,NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);
	
	//initializing OpenGL
	hdc=GetDC(hWnd);
	
	if (!bSetupPixelFormat(hdc))    // This sets our pixel format/information
        PostQuitMessage (0);          // If there's an error, quit
	hrc=wglCreateContext(hdc);
	wglMakeCurrent(hdc,hrc);


	//create fonts for display
	UINT listId=glGenLists(MAXCHARS);
	HFONT font=CreateFont(FONTHEIGHT,0,0,0,FW_BOLD,false,false,false,
		ANSI_CHARSET,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,ANTIALIASED_QUALITY,FF_DONTCARE|DEFAULT_PITCH,"Arial");
		//save old font
	HFONT oldFont=(HFONT)SelectObject(hdc,font);
	fontListId=glGenLists(MAXCHARS);
	wglUseFontBitmaps(hdc,0,MAXCHARS-1,fontListId);

	//load resources
	loadRes();
	// Main message loop:
	while (1) 
	{
		if(PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if(msg.message==WM_QUIT||msg.message==WM_DESTROY)
				break;
			
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}else
		{
			display();
		}
	}
	releaseRes();
	//finalizing OpenGL
	if(hrc)
	{
		wglMakeCurrent(NULL,NULL);
		wglDeleteContext(hrc);
	}
	if(hdc)
		ReleaseDC(hWnd,hdc);

	
	//unregist win class
	UnregisterClass("win",hInstance);    
	return (int) msg.wParam;
}


